package clubs;

import java.util.ArrayList;

public class Club {
	/**
	 * @param args
	 */
	
	protected int id; 
	//the funds of this club, if any
	protected int funds = 0;	
	//minimum number of people required to hold this club ... if there're lesser members
	//the club dissolves
	protected int minimumNumber = 0;	
	protected int membershipType = -1;	
	
	protected ArrayList members;
	
	
	public static class MEMBERSHIP_TYPE {
		//any one can join this club anytime 
		public static final int OPEN = 0;
		//to join, one must be linked (by some relationship) to a member of the club
		//or if one gets an invitation from a member to join the club		
		public static final int BY_REFERENCE = 1;
	}
	
	public Club() {	
	}
	
	public Club(int _membershipType, ArrayList _members) {		
		this.membershipType = _membershipType;
		this.members = _members;
	}
	
	public Club(int _membershipType) {
		this.membershipType = _membershipType;
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
	}		

	public int getFunds() {
		return funds;
	}

	public void setFunds(int _funds) {
		this.funds = _funds;
	}
	
	public void addFunds(int _addition) {
		this.funds += _addition;
	}
	
	public void deductFunds(int _deduction) {
		this.funds -= _deduction;
	}	

	public int getMinimumNumber() {
		return minimumNumber;
	}

	public void setMinimumNumber(int minimumNumber) {
		this.minimumNumber = minimumNumber;
	}

	public int getMembershipType() {
		return membershipType;
	}

	public void setMembershipType(int membershipType) {
		this.membershipType = membershipType;
	}

	public ArrayList getMembers() {
		return members;
	}

	public void setMembers(ArrayList members) {
		this.members = members;
	}
	
	public void addMember(Object _member){
		this.members.add(_member);
	}
	
	public void removeMember(Object _member){
		this.members.remove(_member);
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
}