package clubs;

import infastructure.Settings;
import java.util.ArrayList;
import units.Household;

//public class FuneralClub extends Club {	
public class FuneralClub {	
	private int id = -1;
	private int initialFunds = Settings.FUNERALCLUB_INITIAL_MONEY;	
	private int currentFunds = 0;
	private ArrayList<Household> members = new ArrayList<Household>();
	private ArrayList<Household> requests = new ArrayList<Household>();
	
	public FuneralClub() {		
		//a funeral club is open for anyone
//		super(MEMBERSHIP_TYPE.OPEN);
//		members = new ArrayList<HouseholdCluster>();
	}	
	
	public FuneralClub(int _id) {
		//a funeral club is open for anyone		
//		super(MEMBERSHIP_TYPE.OPEN);
		this.id = _id;
//		members = new ArrayList<HouseholdCluster>();
		this.currentFunds = this.initialFunds;
	}

	public int getCurrentFunds() {
		return currentFunds;
	}

	public void setCurrentFunds(int currentFunds) {
		this.currentFunds = currentFunds;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public ArrayList<Household> getMembers() {
		return members;
	}

	public void setMembers(ArrayList<Household> members) {
		this.members = members;
	}
	
	public void addMember(Household _member){
		this.members.add(_member);
	}
	
	public void removeMember(Household _member){
		this.members.remove(_member);
	}
	
	public void addContribution(int money) {
		this.currentFunds += money;
	}

	
	/*
	 * we need some good decision procedure here ... what we've been able to learn so far
	 * is that funeral clubs/burial societies give full amount to some, and a bit proportion 
	 * of the rest pool to the others who've suffered a breavement ...
	 * this is an important method ... the current implementation is just stylized ... 
	 */
	//CAUTION: STILL WORKING ON THIS FUNCTION ...
	public void step() {
		//first determine how many requests we have 
		int numRequests = this.requests.size();
		//can we give the funeral cost to all of them?
		int share = 0;
		if (this.currentFunds - (Settings.FUNERAL_COST * numRequests) >= 0) {
			share = Settings.FUNERAL_COST;
		}
		//else we give the equal share of money to people  
		else {			
			share = this.currentFunds / numRequests;
		}
		
		for (Household household : this.requests) {		
			//	pay(household, share);
			household.addWealth(share);
		}		
		this.requests.clear();
	}
	
	public void pay(Household household, int share) {
		household.addWealth(share);
	}
	
	public void request(Household household) {
		/*this is also a simplistic assumption .. for testing sake, say, ...
		 * if a hh defaults for some time and doesn't pay ...  
		 * then it doesn't get any help from the club, anymore ... 
		 * it's on its own ... we start testing with 4 (3+1) months ... 		 		
		*/ 
		int diffCount = 3; 
		//also ... if there're multiple deaths (implying multiple requests from a 
		// household, we're dealing with only one at a time ... 
		if ((household.getDefaultFuneralClubCount() <= diffCount) && (!this.requests.contains(household))) {
			this.requests.add(household);
		}		
		else {
//			this.members.remove(household);
		}
	}	
}