package clubs;

import gui.Model;

import infastructure.Settings;

import java.util.ArrayList;
import uchicago.src.sim.util.SimUtilities;
import units.Agent;

/**
 * 
 * TO DO: need mechansim for handling requests for getting money out of turn ... 
 * if more than one agents request, we need to maintain a priority queuue so that
 * which is 'supposed' to be just ... if there is a delay due to the size of members
 * and/or number of requests, a member may opt to leave the saving club and join another
 * but it's a kind of tension ... because a savings club which is older and larger may attract
 * more people than otherwise ... if there're many members, then you can get a much larger 
 * amount of money ... but on the cost that your turn comes late too as the consquence
 *
 *people get togeter to create a savings scheme ... "it appears that some people might be 
 *involved in more than one scheme while others are involved in no schemes."
 *
 * usually formed by women, informally
 */

//public class SavingsClub extends Club {
public class SavingsClub {	
	
	//a savings club may either be disbanded or a new cycle starts 
	private int cycle = 0;
	private int months = 0;	
	private Agent moderator = null;
	private ArrayList<Agent> candidates;
	private Model model;
	private ArrayList<Agent> members;
	private int membershipType = -1;
	
	private boolean viable = true;
		
	public SavingsClub() {				
//		super(MEMBERSHIP_TYPE.BY_REFERENCE);		
		members = new ArrayList<Agent>();
		candidates = new ArrayList<Agent>(members);
	}
	
	public SavingsClub(int _membershipType, Agent _moderator, ArrayList<Agent> _members, Model _model) {
//		super(membershipType, members);				
		this.membershipType = _membershipType;
		this.members = new ArrayList<Agent>(_members);
		this.moderator = _moderator;
		this.model = _model;		
		candidates = new ArrayList<Agent>(_members);		
		initialize();
	}
	
	//for every new cycle ... this methods needs to be called 
	public void initialize() {
		SimUtilities.shuffle(candidates);
		this.cycle++;
//		this.months = members.size(); 
	}
	
//	public Agent chooseRandomNextBenefactor() {
//		//check if the list is empty ... when calling it					
//		if (!members.isEmpty()) {
//			SimUtilities.shuffle(members);			
//			Agent agent = (Agent) members.remove(0);
//			return agent;			
//		}
//		else return null;
//	}
	
	//called from the schedule in the mdoel
	public void step() {
		ArrayList<Agent> temp = new ArrayList<Agent>(this.members);				 
		
		for (Agent agent : temp) {
			boolean flag = false;
			//actually, we can write a better code ... because
			//in the model.mainAction() we have a local list maintaining 
			//the track of agents who've died this month ... 
//			if (!model.getAgentList().contains(agent) && (this.moderator == agent)) { //### this only tests if the moderator died ????
//				System.out.println("*************  SAVINGS MEMBER DEAD");
//				this.moderator = null;
//				flag = true;
//			}
			if (!model.getAgentList().contains(agent)) { 
				System.out.println("*************  SAVINGS MEMBER " + agent.getId() + " DEAD, LEAVES AGENT'S " + moderator.getId() + " STOKVEL");
				if (this.moderator == agent) this.moderator = null;
				flag = true;
			}
			if (agent.isPullOutMembership()) {
				System.out.println("*************  AGENT " + agent.getId() + " PULLED OUT OF AGENT's " + moderator.getId() + " STOKVEL");
				flag = true;
			}
			if (flag) {				
				this.members.remove(agent);
				//### and reset membership flag in agent
				agent.setMemberSavings(false);
				//might already be removed from this list
				this.candidates.remove(agent);
			}
		}		
		//if we're still viable and the minimum members hold ...
		if (this.members.size() >= Settings.MIN_SAVINGS_MEMBERS) {				
			if (this.moderator == null) {
				moderator = (Agent) this.members.get(0);
				moderator.setInnovator(true);
			}		
			if(!this.candidates.isEmpty()){			
				mainStep();
			}
			else {
		    	/*what's missing here is that there's no chance for people to join ...
		    	 * so currently we can't use the restart function ...  
		    	 * instead, we demolish the club after a single rota */
				restart();
//				demolish();
			}
		}
		else {
			//we're no more viable ... we demolish the club ... 
			demolish();
		}	
	}
	
	/*
	 * for restarting the club ... we've got to check if we've the remaining candidates
	 * intact and if they're viable for the club ... 
	 * we might also like to invite more people who're not part of the cycle before 
	 */
	
    public void restart() {    	
    	cycle++;
    	this.candidates = new ArrayList<Agent>(this.members);    	
    }
    
    
	
	public void mainStep() {		
		this.months++;
		int totalPool = 0;
		for (int i=0; i<this.members.size(); i++) {
			totalPool += Settings.STOKVEL_AMOUNT;
		}
		SimUtilities.shuffle(this.candidates);
		Agent recipient = (Agent) this.candidates.get(0);
		recipient.setSavingsPool(totalPool);
		this.candidates.remove(recipient);				
	}
	
	public void demolish() {
		this.viable = false;
		for (Agent agent : (ArrayList<Agent>)this.members) {
			agent.flushMembership();
		}
		
		System.out.println("************* Savings club of agent " + (this.moderator != null ? this.moderator.getId() : -1) + " ceased to exist");
	}
	
	public static void main(String[] args) {		
	}

	public int getCycle() {
		return cycle;
	}

	public Agent getModerator() {
		return moderator;
	}

	public void setModerator(Agent moderator) {
		this.moderator = moderator;
	}

	public void setCycle(int cycle) {
		this.cycle = cycle;
	}

	public int getMonths() {
		return months;
	}

	public void setMonths(int months) {
		this.months = months;
	}

	public boolean isViable() {
		return viable;
	}

	public void setViable(boolean viable) {
		this.viable = viable;
	}

	public ArrayList<Agent> getCandidates() {
		return candidates;
	}

	public void setCandidates(ArrayList<Agent> candidates) {
		this.candidates = candidates;
	}

	public ArrayList<Agent> getMembers() {
		return members;
	}

	public void setMembers(ArrayList<Agent> members) {
		this.members = members;
	}

	public int getMembershipType() {
		return membershipType;
	}

	public void setMembershipType(int membershipType) {
		this.membershipType = membershipType;
	}
}