package economics;

import infastructure.Settings;
import java.util.ArrayList;
import units.Agent;
import gui.Model;

/***
 * this is a a special kind of agent / or agency, so-called 'Finance Agency' ... created as
 * an instituition responsible for allocating grants to agents .. 
 * my gut feeling is that it would be highly inefficient ... my implemntation .. 
 */

public class FinanceAgency {
	private Model model;
	
	public FinanceAgency(Model _model){
		this.model = _model;
	}
	
	public void step() {
		//since grants are (supposedly) allocated on indiviual basis ... 
		ArrayList<Agent> agents = new ArrayList<Agent>();
		agents = (ArrayList<Agent>) model.getAgentList();
		for (Agent agent : agents) {
			allocateGrant(agent);
		}
	}
	
	public void allocateGrant(Agent agent) {
		int ageGroup = agent.getAgeGroup(), health = agent.getHealthStatus();
		
		if (ageGroup == Settings.AGE.CHILD) {
			//the age for child <= 8 is taken from the UNRAVEL Report
			if ((health == Settings.HEALTH_STATUS.HIV) && (agent.getAge() < 7)) {
				agent.setGrant(Settings.CHILD_GRANT);
			}
			else if (agent.isOrphan()) {
				agent.setGrant(Settings.ORPHAN_GRANT);
			}
			
			//need evidence ... 
//			if (agent.isOrphan() && (agent.getAge() <= 8) && (health == Settings.HEALTH_STATUS.HIV)) {
//			if (agent.isOrphan() && (health == Settings.HEALTH_STATUS.HIV)) {
//				agent.setGrant(Settings.ORPHAN_GRANT);
//			}						
		}
		else if ((ageGroup == Settings.AGE.ADULT) 
				&& (health == Settings.HEALTH_STATUS.HIV)
				&& (Math.random() <= Settings.DISABILITY_GRANT_PROBABILITY )) {				
			agent.setGrant(Settings.DISABILITY);
		}
		else if (ageGroup == Settings.AGE.SENIOR) {
			//from the UNRAVEL Report
			if (((agent.getGender() == Settings.GENDER.FEMALE) && (agent.getAge() >= Settings.PENSION_AGE_FEMALE)) 
					|| (agent.getGender() == Settings.GENDER.MALE) && (agent.getAge() >= Settings.PENSION_AGE_MALE)) {
				agent.setGrant(Settings.PENSION_GRANT);							
			}			
		}
		else {
			agent.setGrant(Settings.NO_GRANT);
		}
	}	
	
	public static void main(String[] args) {
	}
}