package infastructure;

public class Settings {	
	public static class GENDER {
		public static final int FEMALE = 0;
		public static final int MALE = 1;		
	}		
	public static class ETHNICITY {
		public static final int BLACK = 0;
		public static final int WHITE = 1;		
	}	
	public static class AGE {
		public static final int CHILD = 0;
		public static final int ADULT = 1;
		public static final int SENIOR = 2;		
	}	
	public static final int CHILD_AGE_LIMIT = 14;
	public static final int ADULT_AGE_LIMIT = 45;
	
	public static class HEALTH_STATUS {
		/* can't recover from HIV, can do some labour*/
		public static final int HIV = 0;		
		/* no labour possible */		
		public static final int DISABLE = 1;		
		/* old age factor, maybe some labour */		
		public static final int OLD_AGE_SICKNESS = 2;
		/* recoverable, can do some labour */		
		public static final int ILL = 3;
		/* can do labour*/
		public static final int WELL = 4;
	}		
	
	/*
	 * right now, what we know is that it's low ... need to 
	 * digout from the fieldwork 
	 */	
	public static final double DISABILITY_GRANT_PROBABILITY = 0.25;
	
	public static final int PENSION_AGE_FEMALE = 55;
	public static final int PENSION_AGE_MALE = 60;	
	
	public static final class MARITAL_STATUS {
		public static final int SINGLE = 0;
		public static final int MARRIED = 1;
		public static final int WIDOWED = 2;
	}	
	
	public static final class MESSAGE_TYPE {
		public static final int NO_MESSAGE = 0;
		public static final int CLUB_INVITATION = 1;
		public static final int ACCEPTANCE = 2;
		public static final int REJECTION = 3;
	}	
	
	public static final double MEAN_LIFE_EXPECTANCY = 66;
	public static final double SD_LIFE_EXPECTANCY = 5;
	
	//this is in months ... 8 years, i.e. 96 months
	public static final int FERTILITY_DURATIION = 96;
	
	/*
	 * In Ziervogel et al. (2005) [UNRAVEL REPORT], it's mentioned that the pension grants can support
	 * entire households since 750 per month is the pension and assuming 6 people on average, in a household
	 * we assume that 125 Rands are required for each member, i.e. 750/6.  
	 * But since grant not only allows to buy food, but also transport and electricity etc. (funeral expenditure, 
	 * savings clubs etc.), we assume the food requirement to be 65 for fed; below is isFed = false;
	 */
	public static final int MONEY_TO_FEED = 65;
	//10kg/month
	public static final int FOOD_NEEDED = 10;
	
	public static final class FEED_STATUS {
		public static final int NOT_FED = 0;		
		public static final int FULL_FED = 1;
		public static final int HALF_FED = 2;		
	}
	
	/* grant types */	
	public static final int NO_GRANT = 0;
	public static final int DISABILITY = 750;
	public static final int PENSION_GRANT = 800;
	public static final int CHILD_GRANT = 125;
	public static final int ORPHAN_GRANT = 175;
//	public static final int CHILD_GRANT = 50;
//	public static final int ORPHAN_GRANT = 50;

	
	//presumably
//	public static final int MARRIAGE_AGE_LIMIT = 30;
	public static final int MARRIAGE_AGE_LIMIT = 45;
		
	/*
	 * The remittance amount is set fixed at the moment; we would like to 
	 * make it appear more plausible as further data are made available. 
	 */
	public static final class REMITTANCE  {
		public static final int MEAN = 300;
		public static final int STD_DEV = 50;
	}	
	
	/*
	 * individuals been absolutely normal,and sometimes except with wt loss,they are perfectly normal
	 * and their health starts to deteriorate only after some time ... could be 6 months - 4 years
	 * depending upon the nature of the HIV variant ... we're not concerned about the HIV variants, so 
	 * we keep it fixed for a mid-val of 18months
	 */
	public static final int INFECTED_LAG = 18;
	//currently 1.0
	public static final double LABOUR_PROBABILITY = 0.40;
//	public static final double LABOUR_PROBABILITY = 1.0;
	
	public static final double MARRIAGE_PROBABILITY = 0.60;
//	public static final double MARRIAGE_PROBABILITY = 1.0;
	
	//initial fund for funeral club ... this is just a magic number... where money comes from somewhere
	//and is assumed to be there before the simulation starts ... of course, a club's money may increase
	//and most likely to decrease ... in case of being broken ... the members may opt to join another, if possible
	public static final int FUNERALCLUB_INITIAL_MONEY = 10000;		
	//assuming the average funeral cost is 5,000 Rands, for all funerals
	//i've changed that to 500 Rands
	public static final int FUNERAL_COST = 500;
//	public static final int FUNERAL_COST = 5000;
	
	public static final double PROPORTION_FARMS = 0.40;
//	public static final double PROPORTION_FARMS = 0.0;
	
	public static final double INNOVATOR_PROBABILITY = 0.20;	

	/*it's for each household ... the value is taken from Heuveline (2004) in which
	 * he says the birth rate is 0.3 per person-year in many of the most affected areas
	 * ... What's required to assure is that I'm using it correctly, or not ???	 * 
	 */ 
//	public static final double BIRTH_PROBABILITY = 0.10;
	public static final double BIRTH_PROBABILITY = 0.30;	
	
	//this is the fictititous amount required to join the stokvel ... 
//	public static final int STOKVEL_AMOUNT = 50;
	public static final int STOKVEL_AMOUNT = 200;
		
	//Upper limit for the number of friends ... 
	public static final int FRIENDSHIP_UPPER_LIMIT = 7;	
	
	//now set critical mass for initiating a savings club
	public static final int MIN_SAVINGS_MEMBERS = 5; //3;
	
	//health expenses cost
	public static final int HEALTH_EXPENSE = 200;
//	public static final int HEALTH_EXPENSE = 500;	

	//initial hh money ; cash in hand
	public static final int STARTING_WEALTH = 5000;

	//this is kept 30 Rands ... some say (probably, Radar) that it's
	// usually 30Rands, could be way higher than 100 Rands as well ... don't know at the moment ... 
//	public static final int FUNERALCLUB_FEE = 200; 
	public static final int FUNERALCLUB_FEE = 1000;
}