package org.cfpm.ruth.modifiedCloud;

import java.util.ArrayList;

/**
 * Title: crop planting rules for the average farmer
 * Description: These farmers only plant for profit, either
 * cabbage late in the year or butternut for Christmas
 * Copyright: Copyright (c) 2004
 * Company: University of Cambridge/SEI Oxford
 * @author Mike Bithell/Sukaina Bharwani
 * @version 1.0
 */
public class averageCropRule extends cropRule{

  /**
   * Get the crop references from the household that owns the rule
   * NB at present there is only ONE of each crop
   * @param m maize
   * @param b butternut
   * @param c cabbage
   */
//  public averageCropRule(Crop m,Crop b,Crop c) {
//    maize=m;butternut=b;cabbage=c;
//  }
//#### no longer needed	

  /**
   * Average farmers always plant butternut as assume demand at Christmas. First plant butternut,
   * then cabbage. If there is enough to plant the whole plot, plant all of it otherwise don't
   * plant at all. Assumption is that they do not plant if they cannot harvest enough
   * to sell at market.
   * @param month current month
   * @param usingForecast is agent using the forecast
   * @param forecast normal, wet or dry
   * @param cashInHand amount or money available
   * @param checkLastYear if checking what was done last year
   * @param wc Climate object
   * @param year current year
   * @return list of chosen crops //####
   */
  public ArrayList calculatePlanting(int month,boolean usingForecast, int forecast,
                                  float cashInHand, boolean checkLastYear, Climate wc, int year ) {
     cost=0;
		 //####
		 ArrayList crops = new ArrayList();
		 // just to facilitate things, since we only have maize, butternut and cabbage
		 Crop maize = new MaizeCrop();
		 Crop butternut = new ButternutCrop();
		 Crop cabbage = new CabbageCrop();
		 //####
	  
//SB     if (!usingForecast)return 0;
     if (month == FarmingWorld.SEPTEMBER ) {
       if (cashInHand >= 750) { //300
         //market crop - average farmer doesn't care about market demand
         butternut.cropMonth = month;
         butternut.plantThisYear = true;
         butternut.area = 1.0f;
         cost=300;
			//###
			crops.add(butternut);
       }
     }
     //plant cabbage in January
     //move to february if forecast is for Below Normal (dry)
     //this is a second crop - previous September crop will have
     //been harvested before Jan. - really need some error
     //checking in the field to stop more then 100% of area
     //begin planted! 3 month crops so this should not cause a problem?
       if (usingForecast){
         if (month == FarmingWorld.JANUARY &&  (forecast == Weather.DRY)){
         //    (month == World.FEBRUARY && forecast == Weather.DRY)) {
           if (cashInHand >= 630) { //180
             //market crop - average farmer doesn't care about market demand
             cabbage.cropMonth = month;
             cabbage.plantThisYear = true;
             cabbage.area = 1.0f;
             cost = 180;
				 //###
				 crops.add(cabbage);
           }
         }
       }
		 //### 
		 System.out.println("-- average: decided to plant maize " + maize.area + ", butternut " + butternut.area + ", cabbage " + cabbage.area);
		 //### 
//		 Crop[] list = new Crop[crops.size()];
//		 for (int i=0; i<list.length; i++){
//			 list[i] = (Crop)crops.get(i);
//		 }
	    return crops;
    }
}

   //added R450 to rule condition to allow for buying 3 months of maize for the household.