package org.cfpm.ruth.modifiedCloud;

/**
 * Title: Sets of rules for household communication
 * Description: Currently there's only one rule, which adjust
 * a household's trust in the forecast depending on that of
 * other households
 * Copyright: Copyright (c) 2004
 * Company:University of Cambridge/SEI Oxford
 * @author Mike Bithell/Sukaina Bharwani
 * @version 1.0
 */
import java.util.*;
public class communicateRules {
  FarmingHousehold owner;
  public communicateRules(FarmingHousehold h) {
    owner=h;
  }
      /**Agents sample trust of all other agents using a weighted average. Trustworthiness
       * changes if interaction is non-linear.
       * @param Linear boolean
       */
      public void pollContacts(boolean Linear) {

       float t = 0, tmp = 1, temp1 = 0;
       ArrayList contacts=owner.world.getContacts();
       int forecast=owner.getForecast();
       int weather=owner.getWeather();
//we imagine that each household talks to all its contacts periodically about
       //how much they trust the forecast, The simplest version has a fixed
       //belief in this agent for how trustworthy each contact is
       //(stored in the Representation class), and simply adjusts the
       // trust of this agent by some (arbitrary)fraction of the mean
       //difference between its own trust and that of others
       //(why should it be like this? no good reason! its just
       //experimental, and has the property that the trust converges to
       // a fixed state or set of states in an unchanging environment
       // - similar to some other ad-hoc models
       //published in JASSS) - note that this is currently switched off
       //as temp1=0
       for (int i = 0; i < contacts.size(); i++) {
         Representation contact = (Representation) contacts.get(i);
         temp1 = contact.target.getTrust() - owner.getTrust();
         t += (tmp * contact.trustworthiness) * temp1;
       }
       float tempinc = t / 999;
       //tempinc gets added to the trust at the perception stage above
       owner.setTempinc(tempinc);
      // A slightly more elaborate version adjusts the percieved trustworthiness
      //of other households according to how well their trust in the
      //forecast seems to match the current state. Another arbitrary
      //constant specifies how much the trsutworthiness changes
       if (!Linear) {

         float stt = 0;
         float decrement=0.1f;
         for (int i = 0; i < contacts.size(); i++) {
           Representation contact = (Representation) contacts.get(i);
           FarmingHousehold h=contact.target;
           float temp = 0;
           if (Math.abs(forecast - weather) >= 1 &&
               h.getUsingForecast()) {
             contact.trustworthiness -= decrement;
           }
           if (Math.abs(forecast - weather) < 0.001 &&
               h.getUsingForecast()) {
             contact.trustworthiness += decrement;
           }
           if (Math.abs(forecast - weather) >= 1 &&
               !h.getUsingForecast()) {
             contact.trustworthiness += decrement;
           }
           if (Math.abs(forecast - weather) < 0.001 &&
               !h.getUsingForecast()) {
             contact.trustworthiness -= decrement;
           }
           if (contact.trustworthiness < 0.) {
             contact.trustworthiness=0;
           }

           stt += contact.trustworthiness;
         }
//Re-normalize trustworthiness so that the sum over all contacts is one
         if (stt != 0) {
           for (int i = 0; i < contacts.size(); i++) {
             Representation contact = (Representation) contacts.get(i);
             float temp = 0;
             //temp = contact.trustworthiness * 1000;
             //temp = temp / stt;
             contact.trustworthiness=contact.trustworthiness/stt;
           }
         }
       }
   }

}
