package org.cfpm.ruth.modifiedCloud;

import java.util.ArrayList;
/**
 * Title: Abstract base class for crop rules
 * Description: defines the required function call for setting crop
 * planting times and areas
 * Copyright: Copyright (c) 2004
 * Company: University of Cambridge
 * @author Mike Bithell
 * @version 1.0
 */

public abstract class cropRule {
  //#### Crop maize,butternut,cabbage;
  float cost;
  //#### public void cropRule(Crop m,Crop b,Crop c){}
  
  public cropRule() {
	  this.cost = 0;
  }
  

  /* Calculate the crops that are to be planted, and set their planting
   * months and areas. Return the total cost of planting.
   * Note that this function is called every month, and then planting follows
   * changes of planting date must be treated carefully to ensure
   * a unique crop set in each of the two planting seasons.
   * Its assumed the sub-class constructor will take a list of the
   * crops that are defined in the Household.
   * @param month int
   * @param usingForecast boolean
   * @param forecast int
   * @param cashInHand float
   * @param checkLastYear boolean
   * @param c Climate
   * @param year int
   * @return float - total cost of planting
   */
 //##### public abstract float calculatePlanting(int month,boolean usingForecast,int forecast, float cashInHand,boolean checkLastYear, Climate c, int year);

  /* Calculate the crops that are to be planted, and set their planting
   * months and areas. Return them as a list of crops. Store the total cost of planting in field cost.
   * Note that this function is called every month, and then planting follows
   * changes of planting date must be treated carefully to ensure
   * a unique crop set in each of the two planting seasons.
   * @param month int
   * @param usingForecast boolean
   * @param forecast int
   * @param cashInHand float
   * @param checkLastYear boolean
   * @param c Climate
   * @param year int
   * @return ArrayList list of planned crops
   */
  public abstract ArrayList calculatePlanting(int month,boolean usingForecast,int forecast, float cashInHand,boolean checkLastYear, Climate c, int year);
  //####
  
	//#### use getter/setter methods to access field cost
	public float getCost() {
		return cost;
	}


	public void setCost(float cost) {
		this.cost = cost;
	}
}
