package org.cfpm.ruth.modifiedCloud;

/**
 * Title: A place to store grain
 * Description: currently just stores one type of food for 12 months
 * Copyright: Copyright (c) 2004
 * Company:University of Cambridge/SEI Oxford
 * @author Mike Bithell/Sukaina Bharwani
 * @version 1.0
 */

public class foodStore {
  private int maxFoodAge = 12;//number of timeseps for which food can be stored
  private double store[] = new double[maxFoodAge];
  private float total;
  private FarmingHousehold owner;
  public foodStore(FarmingHousehold h) {
    owner=h;
  }
  public void setStore(float s) {
    for (int age = 0; age < maxFoodAge; age++)
      store[age] = 0;
    store[0] = s;
    total = s;
  }
  /**
   * Food is kept in and array with a number of slots (maxFoodAge)
   * food can be kept for a maximum of maxFoodAge timesteps
   * Each timestep we throw out the oldest stuff (if any)
   * in store[maxFoodAge-1], and move the rest of the food down
   * one notch in age. Currently only one kind of food is avaiable.
   * Deficits of food  accumulate from timestep to timestep!        #### is that really the correct way??? 
   * @param inputFood food that can be added to storage
   * @param consumption food requirements for the household
   */
  public void eat(float inputFood,float consumption){
     for (int age = maxFoodAge - 1; age > 0; age--) {
      store[age] = store[age - 1];
      if (store[age] < 0) {
        store[age] = 0;
      }
    }
    store[0] = 0;//the newest food

  //add any new food - a negative input is
  //a loss of stored food - currently only the
  //oldest stuff gets lost
  if (inputFood < 0)
    store[maxFoodAge - 1] += inputFood;    
  else
    store[0] += inputFood;


  //now eat food - try to eat the oldest.
  //if there is no food this old, we get a
  //negative value- propagate this up toward
  //newer food.
  store[maxFoodAge - 1] -= consumption;
  //eat newer food if the old food has run out
  for (int age = maxFoodAge - 1; age > 0; age--) {
    if (store[age] < 0) {
      store[age - 1] += store[age];
      store[age] = 0;
    }
  }
 //if store[0] ends up negative, we ran out!
 //record this in deficit.
  if (store[0] < 0) {
    owner.addToDeficit(store[0]);
    store[0] = 0;
  }

 //final total - use this to work out what needs planting
  total = 0;
  for (int age = 0; age < maxFoodAge; age++)
    total += store[age];

 //deficits of food  accumulate from timestep to timestep!
 }

  /**
   * Store some food in the newest storage slot
   * @param f float
   */
  public void add(float f) {
    store[0]+=f;
  }
  public float getTotal(){
    return total;
  }
  
  //#####
  public String toString(){
	  StringBuffer buf = new StringBuffer("food in store: ");
	  for (int i=0; i<store.length; i++){
		  buf.append(store[i]);
		  buf.append(" ");
	  }
	  return buf.toString();
  }
}
