package org.cfpm.ruth.modifiedCloud;

import java.util.ArrayList;

/**
 * Title: Crop planting for poor farmers
 * Description: Poorer farmer rules to decide which crop to plant depending
 * on the weather and whether they are using the forecast
 * Copyright: Copyright (c) 2004
 * Company: University of Cambridge/SEI Oxford
 * @author Mike Bithell/Sukaina Bharwani
 * @version 1.0
 */

public class poorCropRule extends cropRule {
 //#### Crop maize, butternut, cabbage;
	
	//#### removed constructor; no longer necessary
//  public poorCropRule(Crop m, Crop b, Crop c) {
//    //get the crop references from the household that owns the rule
//    //NB at present there is only ONE of each crop
//    maize = m;
//    butternut = b;
//    cabbage = c;
//  }

  
  //##### bad programming practice: changing area of crops here instead of when crop is actually planted!
  //##### changed to returning values in a crop list 
  //##### --> means that the crop references (maize, butternut, cabbage) are superfluous now!
  public ArrayList calculatePlanting(int month, boolean usingForecast, int forecast,
                                 float cashInHand, boolean checkLastYear, Climate wc, int year) {
    this.cost = 0;
	 //####
	 ArrayList crops = new ArrayList();
	 // just to facilitate things, since we only have maize, butternut and cabbage
	 Crop maize = new MaizeCrop();
	 Crop butternut = new ButternutCrop();
	 Crop cabbage = new CabbageCrop();
	 //####
	 
    if (month == FarmingWorld.SEPTEMBER) { //regardless of forecast as for subsistence
        if (cashInHand < 435) { //120
	         maize.cropMonth = month;
	         maize.area = 0.25f;
	         maize.plantThisYear = true;
			   crops.add(maize);					//####
            cost = 0; // 0.25 is seed that has been saved or given from others to help out in a bad year.
        }

      //subsistence crop - if there is enough money, always plant the whole area in September by default
      //unless were using the forecast and its dry (see below)

      if (!usingForecast || ! (forecast == Weather.DRY)) {
        if (cashInHand >= 435) { //120
         maize.cropMonth = month;
          maize.area = 1.0f;
          maize.plantThisYear = true;
			   crops.add(maize);					//####
          cost = 120;
        }
      }

//SB  plant 50% butternut regardless of using forecast since expect market demand in Christmas period.

      //include check if last year like this year
      if (cashInHand >= 525) { //210 //(30lines*.5*10R/line)150+(30lines*.5*4R/line)60
        //always high market demand for butternut
        butternut.cropMonth = month;
        butternut.area = 0.5f;
        butternut.plantThisYear = true;
        maize.area = 0.5f;
		  //####
        maize.cropMonth = month;			
        maize.plantThisYear = true;		
		   crops.add(maize);					
			crops.add(butternut);		
			//####
        cost = 210;

        //---------------------------------
        //if usingForecast OR if checking last year and dry
        //checking last year only works to change the area here since the forecast would be required
        //for a major decision such as introducing cabbage.
        //if its anticipated a dry year, from the forecast, or because last year was dry,
        //farmers assume that demand for butternut
        //is increased
        if (cashInHand >= 570) { //255
          if ( (usingForecast && (forecast == Weather.DRY)) ||
              (checkLastYear && year > 0 && (wc.climate_history[year - 1] == Weather.DRY))) { //### year > 0 constraint added, otherwise you get an ArrayOutOfBoundsException
            //include OR if checking last year and dry
            butternut.area = 0.75f;
            maize.area = 0.25f;
				//####
		      butternut.cropMonth = month;
		      butternut.plantThisYear = true;
				maize.cropMonth = month;
				maize.plantThisYear = true;
				crops.add(maize);					
				crops.add(butternut);		
				//####
           cost = 255;
          }
        }
      }
    }
    //if its going to be dry, plant the maize later in the season
    //Too late for butternut - need to address maize planted in october...same conditions as above...
    //look at this
    if (month == FarmingWorld.OCTOBER && (forecast == Weather.DRY) && usingForecast) {
              if (cashInHand >= 435) { //120
                maize.cropMonth = month;
                maize.area = 1.0f;
                maize.plantThisYear = true;
                maize.cropMonth = month;
					 crops.add(maize);					//####
               cost = 120;
              }
    }
    //second crop of the year - assume that the previous crop is harvested
    //NOTE potential bugAlert!
    //since there is only one of each crop this MUST be true
    //otherwise the second crop may not get planted properly
    if (month == FarmingWorld.JANUARY) {
      //default maize subsistence crop again
      if (cashInHand < 435) { //120
        maize.cropMonth = month;
        maize.area = 0.25f;
        maize.plantThisYear = true;
		  crops.add(maize);					//####
       cost = 0; // this is seed that has been saved or given from others to help out in a bad year.
      }

      if (cashInHand >= 435) { //120
        maize.plantThisYear = true;
        cost = 120;
        maize.area = 1.0f;
        maize.cropMonth = month;
		  crops.add(maize);					//####
      }

      if (usingForecast && (forecast == Weather.DRY)) { // market demand is high
        if (cashInHand >= 450 && cashInHand < 495) { //135  //(30lines*.25*6R/line)45+(30lines*.75*4R/line)90
          cabbage.cropMonth = month;
          cabbage.plantThisYear = true;
          cabbage.area = 0.25f;
          maize.area = 0.75f;
          cost = 135;
			 //####
			 maize.cropMonth = month;
			 maize.plantThisYear = true;
			 crops.add(maize);
			 crops.add(cabbage);
        }
        //if we are rich enough, delay planting until February
        //when there is high market demand (and only plant cabbage
        //see below)??
		  //####		 no longer necessary: we just don't add the crops to the crop list!
//        if (cashInHand >= 495) {
//          cabbage.plantThisYear = false;
//          maize.plantThisYear = false;
//          cost = 0;
//			 //#### reset maize area to 0 (was set above in cashInHand >= 435)  
//			 maize.area = 0;
//        }
      }
    }
	 
    if (month == FarmingWorld.FEBRUARY) {
		 //### This will never be called when planting time is September - January
//		 System.out.println("poorCropRule.calculatePlanting: it's Feb.");
		 //###
		 
      if (usingForecast && (forecast == Weather.DRY)) { // market demand is high
        if (cashInHand >= 495) { //and we are reasonably well off - set higher to allow for cost of buying maize
          //180+60*3*1.75=3 months money for buying maize
          cabbage.cropMonth = month;
          cabbage.plantThisYear = true;
          maize.plantThisYear = false;
          cabbage.area = 1.0f;
          cost = 180;
			 //####
			 crops.add(cabbage);
        }
      }
    }
	 //### 
	 System.out.println("-- poor: decided to plant maize " + maize.area + ", butternut " + butternut.area + ", cabbage " + cabbage.area);
	 //### 
//	 Crop[] list = new Crop[crops.size()];
//	 for (int i=0; i<list.length; i++){
//		 list[i] = (Crop)crops.get(i);
//	 }
    return crops;
  }
}//added R315 to rule condition to allow for buying 3 months of maize for the household.