(import gui.*)
(import units.*)


(defclass model Model)
(defclass agent Agent)
(defclass household Household)

(deftemplate message (slot receiver) (slot sender) (slot type) (slot contents))


;; decision rules concerning savings clubs
(defrule initiate-stokvel 
    (agent (houseHoldID ?h)(innovator TRUE) (head TRUE) (gender Settings.GENDER.FEMALE)(memberSavings FALSE) (committed FALSE)(OBJECT ?agent))
	(household (id ?h) (wealth ?w&:(>= ?w Settings.STOKVEL_AMOUNT)))
    =>
    (call ?agent sendInvitation)
)
;; sendInvitation asserts message facts (type stokvel-invitation) with the agent as sender
;; and all known household heads as receivers

(defrule accept-stokvel-invitation
    (agent (houseHoldID ?h) (memberSavings FALSE) (committed FALSE) (OBJECT ?agent))
    (household (id ?h) (wealth ?w&:(>= ?w Settings.STOKVEL_AMOUNT)))
    ?m <- (message (receiver ?agent) (sender ?sender) (type stokvel-invitation))
    =>
	(assert (message (receiver ?sender) (sender ?agent) (type accept-stokvel)))
    (retract ?m)
    (call ?agent setCommitted TRUE)
)

(defrule reject-stokvel-invitation
    (agent (houseHoldID ?h) (memberSavings FALSE) (committed FALSE) (OBJECT ?agent))
    (household (id ?h) (wealth ?w&:(< ?w Settings.STOKVEL_AMOUNT)))
    ?m <- (message (receiver ?agent) (sender ?sender) (type stokvel-invitation))
    =>
	(assert (message (receiver ?sender) (sender ?agent) (type reject-stokvel)))
    (retract ?m)
)


(defrule add-invitee
    (agent (innovator TRUE) (OBJECT ?innovator))
    ?m <- (message (receiver ?innovator) (sender ?agent) (type accept-stokvel))
    =>
    (call ?innovator handleAcceptance ?agent)
    (retract ?m)
)
;; handleAcceptance checks if every invitee has answered and if there are enough accepts
;; then creates the stokvel

(defrule remove-invitee
    (agent (innovator TRUE) (OBJECT ?innovator))
    ?m <- (message (receiver ?innovator) (sender ?agent) (type reject-stokvel))
    =>
    (call ?innovator handleRejection ?agent)
    (retract ?m)
)

