package units;

public class Couple {
	private Agent male = null, female = null;
	private int lastBirthTick = 0;
	private boolean exists = true;

	public Agent getFemale() {
		return female;
	}

	public void setFemale(Agent female) {
		this.female = female;
	}

	public Agent getMale() {
		return male;
	}

	public void setMale(Agent male) {
		this.male = male;
	}

	public Couple() {		
	}
	
	public Couple (Agent _male, Agent _female) {
		this.male = _male;
		this.female = _female;		
	}
	
	public boolean birthPossible(int currentTick) {
		//of course, this is trivial ... 
		if ((male == null) || (female == null) || (!male.getIsAlive()) || (!female.getIsAlive())) {
			return false;
		}							
		if (!female.fertility(currentTick) || ((lastBirthTick != 0) && (currentTick-lastBirthTick < 12))) {
			return false;
		}		
		lastBirthTick = currentTick;			
		return true;	
	}

	public int getLastBirthTick() {
		return lastBirthTick;
	}

	public boolean isExists() {
		return exists;
	}

	public void setExists(boolean exists) {
		this.exists = exists;
	}	
}